declare type SetStateInternal<T> = {
    _(partial: T | Partial<T> | {
        _(state: T): T | Partial<T>;
    }['_'], replace?: boolean | undefined): void;
}['_'];
export interface StoreApi<T extends object = object> {
    setState: SetStateInternal<T>;
    getState: () => T;
    subscribe: (listener: (state: T, prevState: T) => void) => () => void;
    destroy: () => void;
}
declare type Get<T, K, F = never> = K extends keyof T ? T[K] : F;
export declare type Mutate<S, Ms> = Ms extends [
] ? S : Ms extends [
    [
        infer Mi,
        infer Ma
    ],
    ...infer Mrs
] ? Mutate<StoreMutators<S, Ma>[Mi & StoreMutatorIdentifier], Mrs> : never;
export declare type StateCreator<T extends object, Mis extends [
    StoreMutatorIdentifier,
    unknown
][] = [
], Mos extends [
    StoreMutatorIdentifier,
    unknown
][] = [
], U = T> = ((setState: Get<Mutate<StoreApi<T>, Mis>, 'setState', undefined>, getState: Get<Mutate<StoreApi<T>, Mis>, 'getState', undefined>, store: Mutate<StoreApi<T>, Mis>, $$storeMutations: Mis) => U) & {
    $$storeMutators?: Mos;
};
export interface StoreMutators<S, A> {
}
export declare type StoreMutatorIdentifier = keyof StoreMutators<unknown, unknown>;
declare type CreateStore = {
    <T extends object, Mos extends [
        StoreMutatorIdentifier,
        unknown
    ][] = [
    ]>(initializer: StateCreator<T, [
    ], Mos>): Mutate<StoreApi<T>, Mos>;
    <T extends object>(): <Mos extends [
        StoreMutatorIdentifier,
        unknown
    ][] = [
    ]>(initializer: StateCreator<T, [
    ], Mos>) => Mutate<StoreApi<T>, Mos>;
};
declare const createStore: CreateStore;
export default createStore;
/**
 * @deprecated Use `object` instead of `State`
 */
export declare type State = object;
/**
 * @deprecated Use `Partial<T> | ((s: T) => Partial<T>)` instead of `PartialState<T>`
 */
export declare type PartialState<T extends State> = Partial<T> | ((state: T) => Partial<T>);
/**
 * @deprecated Use `(s: T) => U` instead of `StateSelector<T, U>`
 */
export declare type StateSelector<T extends State, U> = (state: T) => U;
/**
 * @deprecated Use `(a: T, b: T) => boolean` instead of `EqualityChecker<T>`
 */
export declare type EqualityChecker<T> = (state: T, newState: T) => boolean;
/**
 * @deprecated Use `(state: T, previousState: T) => void` instead of `StateListener<T>`
 */
export declare type StateListener<T> = (state: T, previousState: T) => void;
/**
 * @deprecated Use `(slice: T, previousSlice: T) => void` instead of `StateSliceListener<T>`.
 */
export declare type StateSliceListener<T> = (slice: T, previousSlice: T) => void;
/**
 * @deprecated Use `(listener: (state: T) => void) => void` instead of `Subscribe<T>`.
 */
export declare type Subscribe<T extends State> = {
    (listener: (state: T, previousState: T) => void): () => void;
};
/**
 * @deprecated You might be looking for `StateCreator`, if not then
 * use `StoreApi<T>['setState']` instead of `SetState<T>`.
 */
export declare type SetState<T extends State> = {
    _(partial: T | Partial<T> | {
        _(state: T): T | Partial<T>;
    }['_'], replace?: boolean | undefined): void;
}['_'];
/**
 * @deprecated You might be looking for `StateCreator`, if not then
 * use `StoreApi<T>['getState']` instead of `GetState<T>`.
 */
export declare type GetState<T extends State> = () => T;
/**
 * @deprecated Use `StoreApi<T>['destroy']` instead of `GetState<T>`.
 */
export declare type Destroy = () => void;
